-- Select Boundaries
-- // A script that selects the edges of all smoothing groups.
-- // Written by Mr. Bluesummers in less than 30 minutes.  ^__^
-- // Original Idea by Discmage

rollout SelectSmoothingGroupEdges "Select Smoothing Group Edges" width:200 height:100
(
	fn SelectSGEdges AllOrNone TargetGroup =
	(
		undo on
		(
			try
			(
				local EdgeSel = #{}
				local TotalEdges = PolyOp.getNumEdges $
				
				-- For each edge in the object, get the two faces.
				-- If they aren't in the same smoothing group, add it
				-- to the selection bitarray.
				for ThisEdge = 1 to TotalEdges do
				(
					-- Get the edge faces.
					EdgeFaces = PolyOp.getEdgeFaces $ ThisEdge
					
					-- Get their smoothing groups.
					SmoothingGroup1 = PolyOp.getFaceSmoothGroup $ EdgeFaces[1]
					SmoothingGroup2 = PolyOp.getFaceSmoothGroup $ EdgeFaces[2]
					
					if AllOrNone 
					then EdgeSel[ThisEdge] = SmoothingGroup1 != SmoothingGroup2
					else EdgeSel[ThisEdge] = 	(SmoothingGroup1 == TargetGroup and \
												SmoothingGroup2 != TargetGroup) or  \
												(SmoothingGroup2 == TargetGroup and \
												SmoothingGroup1 != TargetGroup)
				)
				
				PolyOp.setEdgeSelection $ EdgeSel
				redrawViews()
			)
			catch()
		)
		
		destroydialog SelectSmoothingGroupEdges
	)
	
	spinner SMGroup "Group ID: " type:#integer range:[1, 32, 1] fieldwidth:32 across:2
	checkbox AllOfThem "All Boarders" offset:[10, 0]
	button SelectThem "Select Them!"
	
	on AllOfThem changed state do SMGroup.Enabled = not state
	on SelectThem pressed do SelectSGEdges AllOfThem.checked (SMGroup.value as integer)
)

CreateDialog SelectSmoothingGroupEdges